#define C_NONE               0
#define C_WHISPER            1
#define C_WHOIS              2
#define C_EMOTE              3
#define C_JOIN               4
#define C_SEND               5
#define C_HELP               6
#define C_BAN                7
#define C_BROWSE             8
#define C_CHLEVEL            9
#define C_CLEAR             10
#define C_CLOAK             11
#define C_CONN              12
#define C_DATAPORT          13
#define C_DISC              14
#define C_EMAIL             15
#define C_KICK              16
#define C_KILL              17
#define C_LEVEL             18
#define C_LIST              19
#define C_MOTD              20
#define C_MUZZLE            21
#define C_WALLOP            22
#define C_PART              23
#define C_PASSWORD          24  
#define C_PING              25
#define C_QUIT              26
#define C_SPEED             27
#define C_STATS             28
#define C_TOPIC             29
#define C_UNBAN             30
#define C_UNMUZZLE          31
#define C_VERSION           32
#define C_SCHEME            33
#define C_ALIAS             34
#define C_AFK               35
#define C_PUBLIC            36
#define C_REPLY             37
#define C_PRIVATE           38
#define C_MAIL              39
#define C_DELMAIL           40
#define C_IGNORE            41
#define C_CHCLEAR           42
#define C_UNIGNORE          43
#define C_CHBAN             44
#define C_CHUNBAN           45
#define C_NUKE              46
#define C_UNNUKE            47
#define C_GLOBAL            48
#define C_CVERSION          49
#define C_ECHO              50
#define C_CHLIMIT           51
#define C_SPING             52
#define C_FRIEND            53
#define C_ENEMY             54
#define C_HOTADD            55
#define C_HOTREM            56
#define C_LISTBANS          57  
#define C_CLIENTINFO        58
#define C_GUSER             59

#define C_OP               100
#define C_DEOP             101
#define C_CHVOICE          102
#define C_CHUNVOICE        103
#define C_LINKS            104
#define C_INVITE           106
#define C_CHMUZZLE         107
#define C_CHUNMUZZLE       108
#define C_USERMODE         109 
#define C_SSTATS           110
#define C_CHMODE           111
#define C_CHWALLOP         112
#define C_KILLGHOST        113
#define C_LOCATE           114
#define C_CLIENTS          115

//#define C_SKILL             21  
//#define C_SREM              41 
//#define C_SLINK             23
//#define C_SUNLINK           53

typedef enum {
  L_LEECH,
  L_USER,
  L_MOD,
  L_ADMIN,
  L_ELITE
} level_t;

typedef enum {
  F_CHAT,
  F_UMOD,
  F_INFO,
  F_MISC,
  F_OP,
  F_MOD,
  F_CLIENT
} folder_t;

#define NO_FOLDERS          7

extern const char FolderNames[NO_FOLDERS][64];

typedef struct {
  char* name;            // name of the command
  char* syntax;          // syntax
  char* description;     // description or (see....) if alias
  level_t level;
  folder_t folder;
  int id;                // command id
  int is_alias;          // 1 if alias otherwise 0
} command_t;

int command_new(int id, char* iname, char* syntax, char* ides,
		level_t level, folder_t ifolder);
int command_rename(int iid, char* iname);
GList* command_search(char* prefix);
command_t* command_is_command(char* iname);
char* command_get_alias_string(int id);
int command_make_alias(char* iname, char* alias);
void command_delete_alias_for(int id);
void command_delete_all();
