typedef struct {
  char* ip;
  unsigned long ip_long;
  int port;
  char* description;
  int fd;
  int input;
  int timeout;
  int cnt;               // intern counter
  int max_cnt;           // max count for timeout
} socket_t;

typedef struct {
  socket_t socket;
  char* nick;
  char* passwd;
  int meta;
  int network;
  int major;
  int minor;
} server_t;

typedef struct {
  gint16 type;
  unsigned char* data;
} napster_command_t;

void connection_close(socket_t* socket, 
		      char* reason);

int connect_napster();
int get_best_server(server_t* server);
int get_best_server_read(gpointer data, gint source, 
			 GdkInputCondition condition);
int connect_to_server();
int server_login(gpointer data, gint source, 
		 GdkInputCondition condition);

int connect_socket(socket_t* s);

int send_command(gint16 type, char* data);
gint send_command_real(napster_command_t* command); 

gint16 receive_command(int sock, char* data);

void create_upload_port(int send);

gint server_get_input(gpointer data, gint source, GdkInputCondition condition);
