#include <sys/time.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "connection.h"
#include "global.h"
#include "transfer.h"
#include "resume.h"
#include "interface.h"
#include "support.h"
#include "callbacks.h"
#include "share.h"
#include "hotlist.h"
#include "commands.h"
#include "chat.h"
#include "dirselect.h"
#include "scheme.h"
#include "mail.h"
#include "handler.h"
#include "search.h"
#include "resume.h"
#include "server.h"
#include "preferences.h"

void setup_preferences(unsigned long flags) {
  
  GtkWidget* win;
  GtkWidget* temp;
  GList* dlist;
  GList* list2;
  int row;
  command_t* command;
  char* pos;
  style_t* style;

  if (!global.options_win) return;
  else win = global.options_win;

  if (flags & P_TREE) {
    GtkCTreeNode* node;
    GtkCTreeNode* node2;
    GtkCTree* ctree;

    ctree = GTK_CTREE(lookup_widget(win, "ctree2"));
    gtk_ctree_set_line_style(ctree, GTK_CTREE_LINES_NONE);
    gtk_ctree_set_expander_style(ctree, GTK_CTREE_EXPANDER_TRIANGLE);
    strcpy(tstr[0], "General");
    node = gtk_ctree_insert_node(ctree, NULL, NULL, list, 15,
				 NULL, NULL, NULL, NULL,
				 FALSE, TRUE);
    gtk_ctree_node_set_row_data(ctree, node, (void*)1);
    strcpy(tstr[0], "Paths");
    node2 = gtk_ctree_insert_node(ctree, node, NULL, list, 15,
				  NULL, NULL, NULL, NULL,
				  TRUE, FALSE);
    gtk_ctree_node_set_row_data(ctree, node2, (void*)2);
    strcpy(tstr[0], "Network");
    node2 = gtk_ctree_insert_node(ctree, node, NULL, list, 15,
				  NULL, NULL, NULL, NULL,
				  TRUE, FALSE);
    gtk_ctree_node_set_row_data(ctree, node2, (void*)3);
    strcpy(tstr[0], "Appearance");
    node = gtk_ctree_insert_node(ctree, NULL, NULL, list, 15,
				 NULL, NULL, NULL, NULL,
				 FALSE, TRUE);
    gtk_ctree_node_set_row_data(ctree, node, (void*)4);
    strcpy(tstr[0], "Schemes");
    node2 = gtk_ctree_insert_node(ctree, node, NULL, list, 15,
				  NULL, NULL, NULL, NULL,
				  TRUE, FALSE);
    gtk_ctree_node_set_row_data(ctree, node2, (void*)5);
    strcpy(tstr[0], "Advanced");
    node = gtk_ctree_insert_node(ctree, NULL, NULL, list, 15,
				 NULL, NULL, NULL, NULL,
				 FALSE, TRUE);
    gtk_ctree_node_set_row_data(ctree, node, (void*)6);
    strcpy(tstr[0], "Aliases");
    node2 = gtk_ctree_insert_node(ctree, node, NULL, list, 15,
				  NULL, NULL, NULL, NULL,
				  TRUE, FALSE);
    gtk_ctree_node_set_row_data(ctree, node2, (void*)7);
    strcpy(tstr[0], "Channels");
    node2 = gtk_ctree_insert_node(ctree, node, NULL, list, 15,
				  NULL, NULL, NULL, NULL,
				  TRUE, FALSE);
    gtk_ctree_node_set_row_data(ctree, node2, (void*)8);

    temp = lookup_widget(win, "frame69");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "frame37");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "frame39");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "frame95");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "frame11");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "frame12");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "frame155");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "frame38");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "frame159");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "frame92");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "frame93");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "label427");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "label428");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "frame167");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "frame67");
    gtk_widget_set_style(temp, global.style[3]);
    temp = lookup_widget(win, "label429");
    gtk_widget_set_style(temp, global.style[3]);
  }
  if (flags & P_NICK) {
    temp = lookup_widget(win, "entry4");
    gtk_entry_set_text(GTK_ENTRY(temp), global.user.username);
  }
  if (flags & P_PASSWD) {
    temp = lookup_widget(win, "entry5");
    gtk_entry_set_text(GTK_ENTRY(temp), global.user.password);
  }  
  if (flags & P_EMAIL) {
    temp = lookup_widget(win, "entry7");
    gtk_entry_set_text(GTK_ENTRY(temp), global.user.email);
  }
  if (flags & P_SPEED) {
    temp = GTK_COMBO(lookup_widget(win, "combo3"))->entry;
    gtk_entry_set_text(GTK_ENTRY(temp), LineSpeed[global.network.linespeed]);
  }
  if (flags & P_PORT) {
    temp = lookup_widget(win, "spinbutton2");
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(temp), (gfloat)global.network.port);
  }
  if (flags & P_AUTOCONNECT) {
    temp = lookup_widget(win, "checkbutton13");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(temp), global.auto_connect);
  }
  if (flags & P_LOG) {
    temp = lookup_widget(win, "checkbutton16");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(temp), global.logging);
  }
  if (flags & P_PLAYER) {
    temp = lookup_widget(win, "entry53");
    if (global.player) {
      gtk_entry_set_text(GTK_ENTRY(temp), global.player);
    } else {
      gtk_entry_set_text(GTK_ENTRY(temp), "");
    }
  }
  if (flags & P_SHARED) {
    int i1;
    
    temp = lookup_widget(win, "clist13");
    for (i1 = 0; i1 < g_list_length(global.path.shared); i1++) {
      strcpy(tstr[0], g_list_nth(global.path.shared, i1)->data);
      gtk_clist_append(GTK_CLIST(temp), list);
    }
  }
  if (flags & P_DOWNLOAD) {
    temp = lookup_widget(win, "entry14");
    if (global.path.download)
      gtk_entry_set_text(GTK_ENTRY(temp), global.path.download);
    else
      gtk_entry_set_text(GTK_ENTRY(temp), "");
  }
  if (flags & P_INCOMPLETE) {
    temp = lookup_widget(win, "entry75");
    if (global.path.incomplete)
      gtk_entry_set_text(GTK_ENTRY(temp), global.path.incomplete);
    else
      gtk_entry_set_text(GTK_ENTRY(temp), "");
  }
  if (flags & P_MAXDOWN) {
    temp = lookup_widget(win, "spinbutton1");
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(temp), (gfloat)global.network.max_downloads);
  }  
  if (flags & P_MAXUP) {
    temp = lookup_widget(win, "spinbutton3");
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(temp), (gfloat)global.network.max_uploads);
  }
  if (flags & P_MAXTRANS) {
    temp = lookup_widget(win, "spinbutton7");
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(temp), (gfloat)global.network.max_transfers);
  }
  if (flags & P_FIREWALL) {
    temp = lookup_widget(win, "checkbutton4");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(temp), global.network.firewall);
  }
  if (flags & P_HIGHLIGHT) {
    temp = lookup_widget(win, "entry42");
    pos = make_string_from_list(global.highlight, "\"");
    gtk_entry_set_text(GTK_ENTRY(temp), pos);
  }
  if (flags & P_FRIEND) {
    temp = lookup_widget(win, "entry44");
    pos = make_string_from_list(global.frienduser, " ");
    gtk_entry_set_text(GTK_ENTRY(temp), pos);
  }
  if (flags & P_ENEMY) {
    temp = lookup_widget(win, "entry52");
    pos = make_string_from_list(global.enemyuser, " ");
    gtk_entry_set_text(GTK_ENTRY(temp), pos);
  }
  if (flags & P_IGNORE) {
    temp = lookup_widget(win, "checkbutton12");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(temp), global.ignore_public_ignore);
  }
  if (flags & P_JOIN) {
    temp = lookup_widget(win, "checkbutton11");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(temp), global.show_joins);
  }
  if (flags & P_SENDIGNORE) {
    temp = lookup_widget(win, "checkbutton15");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(temp), global.send_ignore);
  }
  if (flags & P_PARSE) {
    temp = lookup_widget(win, "checkbutton22");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(temp), global.parse_color);
  }
  if (flags & P_SCHEME) {
    scheme_update_list();

    // the colors
    list2 = NULL;
    temp = lookup_widget(win, "combo5");
    if (global.colors) {
      dlist = g_list_first(global.colors);
      while (dlist) {
	style = (style_t*)(dlist->data);
	list2 = g_list_append (list2, style->name);
	dlist = g_list_next(dlist);
      }
      gtk_combo_set_popdown_strings (GTK_COMBO (temp), list2);
      g_list_free (list2);
    }
  }
  if (flags & P_POPUP1) {
    switch (global.popup_create) {
    case 1:
      temp = lookup_widget(win, "radiobutton1");
      break;
    case 2:
      temp = lookup_widget(win, "radiobutton2");
      break;
    case 3:
      temp = lookup_widget(win, "radiobutton3");
      break;
    default:
      temp = lookup_widget(win, "radiobutton1");
      break;
    }
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(temp), TRUE);
  }
  if (flags & P_ALIAS) {
    list2 = NULL;
    temp = lookup_widget(win, "combo6");
    if (global.commands) {
      dlist = g_list_first(global.commands);
      while (dlist) {
	command = (command_t*)(dlist->data);
	if (command->is_alias == 0)
	  list2 = g_list_append (list2, command->name);
	dlist = g_list_next(dlist);
      }
      gtk_combo_set_popdown_strings (GTK_COMBO (temp), list2);
      g_list_free (list2);
    }
  }
  if (flags & P_CHANNEL) {
    temp = lookup_widget(win, "clist6");
    if (global.channels) {
      for (row = 0; row < g_list_length(global.channels); row++) {
	strcpy(tstr[0], g_list_nth(global.channels, row)->data);
	gtk_clist_append(GTK_CLIST(temp), &list[0]);
      }
    }
    set_options_channels();
  }  
}

void apply_preferences() {
  GtkWidget* win;
  GtkWidget* temp;
  char str[4096];
  int i1;
  char* pos;
  int cnt;
  int do_refresh;

  if (!global.options_win) return;
  else win = global.options_win;

  // general
  temp = lookup_widget(win, "entry4");
  strcpy(global.user.username, gtk_entry_get_text(GTK_ENTRY(temp)));
  temp = lookup_widget(win, "entry5");
  strcpy(global.user.password, gtk_entry_get_text(GTK_ENTRY(temp)));
  temp = lookup_widget(win, "entry7");
  pos = gtk_entry_get_text(GTK_ENTRY(temp));
  if (strcmp(pos, global.user.email)) {
    strcpy(global.user.email, pos);
    send_command(CMD_CLIENT_CHANGE_EMAIL, global.user.email);
  }
  temp = GTK_COMBO(lookup_widget(win, "combo3"))->entry;
  pos = gtk_entry_get_text(GTK_ENTRY(temp));
  i1 = speed2int(pos);
  if (i1 != global.network.linespeed) {
    global.network.linespeed = i1;
    sprintf(str, "%d", global.network.linespeed);
    send_command(CMD_CLIENT_CHANGE_SPEED, str);
  }
  temp = lookup_widget(win, "spinbutton2");
  i1 = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(temp));
  if (global.network.port != i1) {
    create_upload_port(TRUE);
    global.network.port = i1;
  }
  temp = lookup_widget(win, "checkbutton13");
  global.auto_connect =
    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(temp));
  temp = lookup_widget(win, "checkbutton16");
  global.logging =
    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(temp));
  if (global.player) {
    free(global.player);
    global.player = NULL;
  }
  temp = lookup_widget(win, "entry53");
  pos = gtk_entry_get_text(GTK_ENTRY(temp));
  if (strlen(pos) > 0) global.player = strdup(pos);
  
  // paths
  temp = lookup_widget(win, "clist13");
  cnt = 0;
  do_refresh = 0;
  for (i1 = 0; i1 < GTK_CLIST(temp)->rows; i1++) {
    gtk_clist_get_text (GTK_CLIST(temp), i1, 0, &pos);
    if (is_string_in_list(global.path.shared, pos)) cnt++;
  }
  if ((cnt < GTK_CLIST(temp)->rows) ||
      (cnt != g_list_length(global.path.shared))) {
    if (global.path.shared) g_list_free(global.path.shared);
    global.path.shared = NULL;
    for (i1 = 0; i1 < GTK_CLIST(temp)->rows; i1++) {
      gtk_clist_get_text (GTK_CLIST(temp), i1, 0, &pos);
      global.path.shared = 
	g_list_append(global.path.shared, strdup(pos));
    }
    do_refresh = 1;
  }
  
  temp = lookup_widget(win, "entry14");
  if (global.path.download) free(global.path.download);
  global.path.download = strdup(gtk_entry_get_text(GTK_ENTRY(temp)));

  temp = lookup_widget(win, "entry75");
  if (global.path.incomplete) free(global.path.incomplete);
  global.path.incomplete = strdup(gtk_entry_get_text(GTK_ENTRY(temp)));


  // network
  temp = lookup_widget(win, "spinbutton1");
  global.network.max_downloads = 
    gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(temp));
  temp = lookup_widget(global.win, "spinbutton5");
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(temp),
			    global.network.max_downloads);
  temp = lookup_widget(win, "spinbutton3");
  global.network.max_uploads = 
    gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(temp));
  temp = lookup_widget(global.win, "spinbutton6");
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(temp),
			    global.network.max_uploads);
  temp = lookup_widget(win, "spinbutton7");
  global.network.max_transfers = 
    gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(temp));
  temp = lookup_widget(global.win, "spinbutton8");
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(temp),
			    global.network.max_transfers);
  temp = lookup_widget(win, "checkbutton4");
  global.network.firewall =
    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(temp));


  temp = lookup_widget(win, "entry42");
  pos = strdup(gtk_entry_get_text(GTK_ENTRY(temp)));
  make_list_from_string(&global.highlight, pos, "\"");
  free(pos);
  pos = make_string_from_list(global.highlight, "\"");
  gtk_entry_set_text(GTK_ENTRY(temp), pos);
  temp = lookup_widget(global.win, "entry45");
  gtk_entry_set_text(GTK_ENTRY(temp), pos);
  temp = lookup_widget(global.win, "button122");
  gtk_widget_set_sensitive(temp, FALSE);

  temp = lookup_widget(win, "entry44");
  pos = strdup(gtk_entry_get_text(GTK_ENTRY(temp)));
  make_list_from_string(&global.frienduser, pos, " ");
  free(pos);
  pos = make_string_from_list(global.frienduser, " ");
  gtk_entry_set_text(GTK_ENTRY(temp), pos);
  temp = lookup_widget(global.win, "entry46");
  gtk_entry_set_text(GTK_ENTRY(temp), pos);
  temp = lookup_widget(global.win, "button123");
  gtk_widget_set_sensitive(temp, FALSE);

  temp = lookup_widget(win, "entry52");
  pos = strdup(gtk_entry_get_text(GTK_ENTRY(temp)));
  make_list_from_string(&global.enemyuser, pos, " ");
  free(pos);
  pos = make_string_from_list(global.enemyuser, " ");
  gtk_entry_set_text(GTK_ENTRY(temp), pos);
  temp = lookup_widget(global.win, "entry51");
  gtk_entry_set_text(GTK_ENTRY(temp), pos);
  temp = lookup_widget(global.win, "button124");
  gtk_widget_set_sensitive(temp, FALSE);

  temp = lookup_widget(win, "checkbutton11");
  global.show_joins =
    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(temp));
  temp = lookup_widget(global.win, "checkbutton7");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(temp),
			       global.show_joins);
  
  temp = lookup_widget(win, "checkbutton12");
  global.ignore_public_ignore =
    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(temp));
  temp = lookup_widget(global.win, "checkbutton10");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(temp),
			       global.ignore_public_ignore);

  temp = lookup_widget(win, "checkbutton15");
  global.send_ignore =
    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(temp));
  temp = lookup_widget(global.win, "checkbutton14");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(temp),
			       global.send_ignore);

  temp = lookup_widget(win, "checkbutton22");
  global.parse_color =
    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(temp));
  temp = lookup_widget(global.win, "checkbutton21");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(temp),
			       global.parse_color);



  // setting up new color scheme
  temp = lookup_widget(win, "combo_entry15");
  pos = gtk_entry_get_text(GTK_ENTRY(temp));
  if (scheme_is_valid(pos)) {
    global.colors = scheme_load(global.colors, global.scheme);
  }

  // saving color scheme
  //  on_button100_clicked(NULL, NULL);
  
  // advanced
  temp = lookup_widget(win, "radiobutton1");
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(temp)))
    global.popup_create = 1;
  temp = lookup_widget(win, "radiobutton2");
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(temp)))
    global.popup_create = 2;
  temp = lookup_widget(win, "radiobutton3");
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(temp)))
    global.popup_create = 3;

  // channels
  if (global.channels) {
    g_list_free(global.channels);
    global.channels = NULL;
  }
  temp = lookup_widget(win, "clist6");
  for (i1 = 0; i1 < GTK_CLIST(temp)->rows; i1++) {
    gtk_clist_get_text(GTK_CLIST(temp), i1, 0, &pos);
    global.channels = 
      g_list_insert_sorted(global.channels, strdup(pos),
			   (GCompareFunc)strcasecmp);
  }

  write_rc();

  if (do_refresh) lib_refresh();
}
