#include <string.h>
#include <stdio.h>
#include <sys/time.h>
#include <stdlib.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "connection.h"
#include "global.h"
#include "search.h"
#include "handler.h"
#include "support.h"
#include "transfer.h"
#include "resume.h"

GtkWidget* create_search_list_popup(int row) {
  GtkWidget *search_list_popup;
  GtkAccelGroup *search_list_popup_accels;
  GtkWidget *download;
  GtkWidget *download_selected;
  GtkWidget *trennlinie1;
  GtkWidget *clear_selected;
  GtkWidget *clear_users_files;
  GtkWidget *clear_all;
  GtkWidget *trennlinie13;
  GtkWidget *add_user_to_hotlist;
  GtkWidget *who_is_user;
  GtkWidget *trennlinie17;
  GtkWidget *customize_list3;
  GtkCList* clist;
  char item_str[1024];
  int item_num;

  search_list_popup = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (search_list_popup), "search_list_popup", search_list_popup);
  search_list_popup_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (search_list_popup));
  clist = GTK_CLIST(lookup_widget(global.win, "search_list"));
  item_num = g_list_length(clist->selection);
  
  if (row) {
    if (item_num < 2) {
      download = gtk_menu_item_new_with_label ("Download");
      gtk_widget_ref (download);
      gtk_object_set_data_full (GTK_OBJECT (search_list_popup), "download", download,
				(GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (download);
      gtk_container_add (GTK_CONTAINER (search_list_popup), download);
      gtk_signal_connect (GTK_OBJECT (download), "activate",
			  GTK_SIGNAL_FUNC (on_download_activate),
			  NULL);
    } else {
      sprintf(item_str, "Download Selected (%d)", item_num);
      download_selected = gtk_menu_item_new_with_label (item_str);
      gtk_widget_ref (download_selected);
      gtk_object_set_data_full (GTK_OBJECT (search_list_popup), "download_selected", download_selected,
				(GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (download_selected);
      gtk_container_add (GTK_CONTAINER (search_list_popup), download_selected);
      gtk_signal_connect (GTK_OBJECT (download_selected), "activate",
			  GTK_SIGNAL_FUNC (on_download_selected_activate),
			  NULL);
    }
    
    trennlinie1 = gtk_menu_item_new ();
    gtk_widget_ref (trennlinie1);
    gtk_object_set_data_full (GTK_OBJECT (search_list_popup), "trennlinie1", trennlinie1,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (trennlinie1);
    gtk_container_add (GTK_CONTAINER (search_list_popup), trennlinie1);
    gtk_widget_set_sensitive (trennlinie1, FALSE);
    
    sprintf(item_str, "Clear Selected (%d)", item_num);
    clear_selected = gtk_menu_item_new_with_label (item_str);
    gtk_widget_ref (clear_selected);
    gtk_object_set_data_full (GTK_OBJECT (search_list_popup), "clear_selected", clear_selected,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (clear_selected);
    gtk_container_add (GTK_CONTAINER (search_list_popup), clear_selected);
    gtk_signal_connect (GTK_OBJECT (clear_selected), "activate",
			GTK_SIGNAL_FUNC (on_clear_selected_activate),
			NULL);
    
    clear_users_files = gtk_menu_item_new_with_label ("Clear Users Files");
    gtk_widget_ref (clear_users_files);
    gtk_object_set_data_full (GTK_OBJECT (search_list_popup), "clear_users_files", clear_users_files,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (clear_users_files);
    gtk_container_add (GTK_CONTAINER (search_list_popup), clear_users_files);
    gtk_signal_connect (GTK_OBJECT (clear_users_files), "activate",
			GTK_SIGNAL_FUNC (on_clear_users_files_activate),
			NULL);
    
    clear_all = gtk_menu_item_new_with_label ("Clear All");
    gtk_widget_ref (clear_all);
    gtk_object_set_data_full (GTK_OBJECT (search_list_popup), "clear_all", clear_all,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (clear_all);
    gtk_container_add (GTK_CONTAINER (search_list_popup), clear_all);
    gtk_signal_connect (GTK_OBJECT (clear_all), "activate",
			GTK_SIGNAL_FUNC (on_clear_all_activate),
			NULL);
    
    trennlinie13 = gtk_menu_item_new ();
    gtk_widget_ref (trennlinie13);
    gtk_object_set_data_full (GTK_OBJECT (search_list_popup), "trennlinie13", trennlinie13,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (trennlinie13);
    gtk_container_add (GTK_CONTAINER (search_list_popup), trennlinie13);
    gtk_widget_set_sensitive (trennlinie13, FALSE);
    
    add_user_to_hotlist = gtk_menu_item_new_with_label ("Add User to Hotlist");
    gtk_widget_ref (add_user_to_hotlist);
    gtk_object_set_data_full (GTK_OBJECT (search_list_popup), "add_user_to_hotlist", add_user_to_hotlist,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (add_user_to_hotlist);
    gtk_container_add (GTK_CONTAINER (search_list_popup), add_user_to_hotlist);
    gtk_signal_connect (GTK_OBJECT (add_user_to_hotlist), "activate",
			GTK_SIGNAL_FUNC (on_add_user_to_hotlist_activate),
			NULL);
    
    who_is_user = gtk_menu_item_new_with_label ("Who is User");
    gtk_widget_ref (who_is_user);
    gtk_object_set_data_full (GTK_OBJECT (search_list_popup), "who_is_user", who_is_user,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (who_is_user);
    gtk_container_add (GTK_CONTAINER (search_list_popup), who_is_user);
    gtk_signal_connect (GTK_OBJECT (who_is_user), "activate",
			GTK_SIGNAL_FUNC (on_who_is_user_activate),
			NULL);
    
    trennlinie17 = gtk_menu_item_new ();
    gtk_widget_ref (trennlinie17);
    gtk_object_set_data_full (GTK_OBJECT (search_list_popup), "trennlinie17", trennlinie17,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (trennlinie17);
    gtk_container_add (GTK_CONTAINER (search_list_popup), trennlinie17);
    gtk_widget_set_sensitive (trennlinie17, FALSE);
  }
    
  customize_list3 = gtk_menu_item_new_with_label ("Customize List");
  gtk_widget_ref (customize_list3);
  gtk_object_set_data_full (GTK_OBJECT (search_list_popup), "customize_list3", customize_list3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (customize_list3);
  gtk_container_add (GTK_CONTAINER (search_list_popup), customize_list3);
  gtk_signal_connect (GTK_OBJECT (customize_list3), "activate",
                      GTK_SIGNAL_FUNC (on_customize_list_activate),
                      NULL);

  return search_list_popup;
}

void update_search_stats() {
  GtkWidget* temp;
  int i1;
  char t[1024];

  temp = lookup_widget(global.win, "search_list");
  i1 = GTK_CLIST(temp)->rows;
  temp = lookup_widget(global.win, "search_entry");
  if (global.status.searching > 0) {
    sprintf(t, "%d search results....searching (%d)...", i1, global.status.searching);
  } else {
    sprintf(t, "%d search results", i1);
  }
  gtk_entry_set_text(GTK_ENTRY(temp), t);
}

void cmd_search_response(char* data) {
  file_t* file;
  char* pos;
  resume_t* resume;

  file = file_create_from_search_response(data);
  
  pos = strrchr(file->longname, '/');
  if (!pos) pos = file->longname;
  else pos++;
  resume = resume_list_search(pos);
  if (resume && (resume->size == file->size)) {
    file_insert_resume(resume, file);
  } else {
    file_insert_search(file);
    update_search_stats();
  }
}

void cmd_end_of_search() {

  if (global.status.searching == 0) return;

  global.status.searching--;
  update_search_stats();
}

file_t* file_create_from_search_response(char* data) {
  file_t* new_file;
  char* pos1;
  char* pos2;

  new_file = (file_t*)malloc(sizeof(file_t));

  pos1 = strchr(data, '\"')+1;
  pos2 = strrchr(data, '\"');
  pos2[0] = '\0';
  new_file->winname = strdup(pos1);

  pos1 = pos2+2;
  pos2 = strchr(pos1, ' ');
  pos2[0] = 0;
  new_file->md5 = strdup(pos1);

  pos1 = pos2+1;
  pos2 = strchr(pos1, ' ');
  pos2[0] = 0;
  sscanf(pos1, "%ld", &(new_file->size));

  pos1 = pos2+1;
  pos2 = strchr(pos1, ' ');
  pos2[0] = 0;
  sscanf(pos1, "%d", &(new_file->bitrate));

  pos1 = pos2+1;
  pos2 = strchr(pos1, ' ');
  pos2[0] = 0;
  sscanf(pos1, "%d", &(new_file->frequency));

  pos1 = pos2+1;
  pos2 = strchr(pos1, ' ');
  pos2[0] = 0;
  sscanf(pos1, "%d", &(new_file->length));

  pos1 = pos2+1;
  pos2 = strchr(pos1, ' ');
  pos2[0] = 0;
  new_file->user = strdup(pos1);

  pos1 = pos2+1;
  pos2 = strchr(pos1, ' ');
  pos2[0] = 0;
  sscanf(pos1, "%lu", &(new_file->ip));

  pos1 = pos2+1;
  sscanf(pos1, "%d", &(new_file->linespeed));
  
  new_file->longname = strdup(new_file->winname);
  convert_to_unix(new_file->longname);
  pos1 = extract_short_name(new_file->longname);
  new_file->shortname = strdup(pos1);

  new_file->ping = -1;
  new_file->flags = 0;
  new_file->status = FILE_NONE;

  return new_file;
}

void send_search_request(gboolean local) {
  GtkWidget* temp;
  char data[1024];
  char str[500];
  char str2[500];
  char str3[500];
  int val1, val2;

  if (!global.status.connected) {
    g_warning("not connected!");
    return;
  }
  global.status.searching++;

  update_search_stats();

  data[0] = 0;
  temp = lookup_widget(global.win, "search_artist");
  strcpy(str, gtk_entry_get_text(GTK_ENTRY(temp)));
  if (strlen(str) > 0) {
    sprintf(str2, "FILENAME CONTAINS \"%s\" ", str);
    strcat(data, str2);
  }
  temp = lookup_widget(global.win, "search_results");
  sprintf(str, "%d", 
	  gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(temp)));
  sprintf(str2, "MAX_RESULTS %s", str);
  strcat(data, str2);
  
  temp = lookup_widget(global.win, "combo_speed");
  strcpy(str, gtk_entry_get_text(GTK_ENTRY(temp)));
  if (strlen(str) > 0) {
    temp = lookup_widget(global.win, "combo_speed2");
    strcpy(str2, gtk_entry_get_text(GTK_ENTRY(temp)));
    if (strlen(str2) > 0) {
      sprintf(str3, " LINESPEED \"%s\" %d", str, speed2int(str2));
      strcat(data, str3);
    }
  }

  temp = lookup_widget(global.win, "combo_bitrate");
  strcpy(str, gtk_entry_get_text(GTK_ENTRY(temp)));
  if (strlen(str) > 0) {
    temp = lookup_widget(global.win, "combo_bitrate2");
    strcpy(str2, gtk_entry_get_text(GTK_ENTRY(temp)));
    if (strlen(str2) > 0) {
      sprintf(str3, " BITRATE \"%s\" \"%s\"", str, str2);
      strcat(data, str3);
    }
  }

  temp = lookup_widget(global.win, "combo_freq");
  strcpy(str, gtk_entry_get_text(GTK_ENTRY(temp)));
  if (strlen(str) > 0) {
    temp = lookup_widget(global.win, "combo_freq2");
    strcpy(str2, gtk_entry_get_text(GTK_ENTRY(temp)));
    if (strlen(str2) > 0) {
      sprintf(str3, " FREQ \"%s\" \"%s\"", str, str2);
      strcat(data, str3);
    }
  }

  if (opennap_version(0, 37)) {
    temp = lookup_widget(global.win, "entry71");
    strcpy(str, gtk_entry_get_text(GTK_ENTRY(temp)));
    if (strlen(str) > 0) {
      temp = lookup_widget(global.win, "spinbutton12");
      val1 = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(temp));
      temp = lookup_widget(global.win, "spinbutton13");
      val2 = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(temp));
      sprintf(str3, " DURATION \"%s\" \"%d\"", str, val1*60+val2);
      strcat(data, str3);
    }
    
    temp = lookup_widget(global.win, "entry70");
    strcpy(str, gtk_entry_get_text(GTK_ENTRY(temp)));
    if (strlen(str) > 0) {
      temp = lookup_widget(global.win, "spinbutton10");
      val1 = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(temp));
      temp = lookup_widget(global.win, "spinbutton11");
      val2 = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(temp));
      sprintf(str3, " SIZE \"%s\" \"%d\"", str, (val1*1024+val2)*1024);
      strcat(data, str3);
    }
    
    temp = lookup_widget(global.win, "entry69");
    strcpy(str, gtk_entry_get_text(GTK_ENTRY(temp)));
    if (strlen(str) > 0) {
      sprintf(str2, " FILENAME EXCLUDES \"%s\"", str);
      strcat(data, str2);
    }
    
    temp = lookup_widget(global.win, "combo_entry17");
    strcpy(str, gtk_entry_get_text(GTK_ENTRY(temp)));
    if (strlen(str) > 0) {
      sprintf(str3, " TYPE %s", str);
      strcat(data, str3);
    }
    
    if (local) strcat(data, " LOCAL");
  }

  send_command(CMD_CLIENT_SEARCH, data);
}

void file_insert_search(file_t *file) {
  GtkWidget* temp;
  int row;
  GdkPixmap *pixmap = NULL;
  GdkBitmap *bitmap = NULL;
  
  temp = lookup_widget(global.win, "search_list");
  
  strcpy(tstr[0], file->shortname);
  sprintf(tstr[1], "%.2f MB", (double)(file->size)/1024/1024);
  sprintf(tstr[2], "%d", file->bitrate);
  sprintf(tstr[3], "%d:%s%d", file->length/60, 
	  (file->length%60)<10?"0":"", file->length%60);
  strcpy(tstr[4], file->user);
  strcpy(tstr[5], LineSpeed[file->linespeed]);
  strcpy(tstr[6], "unknown");

  row = gtk_clist_append(GTK_CLIST(temp), &list[0]);
  gtk_clist_set_row_data_full (GTK_CLIST(temp), row,
			       (gpointer)file,
			       (GtkDestroyNotify)destroy_file_row);

  detect_speed_pixs(file->linespeed, &pixmap, &bitmap);

  gtk_clist_set_pixtext (GTK_CLIST(temp), row, 0,
			 tstr[0], 5, pixmap, bitmap);
}

